/*
 * PROJECT C Library, X68000 PROGRAMMING INTERFACE DEFINITION
 * --------------------------------------------------------------------
 * This file is written by the Project C Library Group,  and completely
 * in public domain. You can freely use, copy, modify, and redistribute
 * the whole contents, without this notice.
 * --------------------------------------------------------------------
 * $Id: $
 */

/* System headers */
#include <sys/dos.h>
#include <sys/stat.h>
#include <sys/xstat.h>

/* Macros */
#define PDRIVETABLE ((unsigned char *)0x1c7e)
#define DRIVEINFPTR ((unsigned int *)0x1c38)

/* Functions */
int _isremotefs (int drive)
{
    int rc;
    int ssp;
    int pdrive, isremotefs;
    dpbsrc_t *dpbp;
    struct _dpbptr dpb;

    /* DPB obt@ɓǂݍ */
    if ((rc = _dos_getdpb (drive, &dpb)) < 0) {
	unsigned char buffer[100];

	if (rc == _DOSE_ILGPARM) {
	    rc = _dos_ioctrlfdctl (drive, 0, buffer);
	    if (buffer[1] == 0xf5)
		return -1;  /* CD-ROM hCuł */
	}
    }

    /* hCuԍɕϊ */
    pdrive = PDRIVETABLE[drive];

    /* X[p[oCU[[h */
    ssp = _dos_super (0);

    /* DPB ̃|C^̌vZ */
    dpbp = *(dpbsrc_t **) (*DRIVEINFPTR + (pdrive * 0x4e) + 0x46);

    /* ZN^̃oCg 0 Ȃ烊[gt@CVXe */
    isremotefs = dpbp->byte ? 0 : 1;

    /* [U[[h֖߂ */
    if (ssp > 0)
	_dos_super (ssp);

    return isremotefs;
}

/* EOF */
